package com.shiny.keyboard

import android.app.Application
import android.graphics.Typeface
import com.anythink.core.api.ATSDK
import com.anythink.core.api.NetTrafficeCallback
import com.shiny.keyboard.ad.AdManager
import com.shiny.keyboard.bean.ChildData
import com.shiny.keyboard.bean.ClassData
//import com.pretty.keyboard.theme.keyboard.helper.ObjectBox
import org.json.JSONArray
import java.io.BufferedReader
import java.io.IOException
import java.io.InputStream
import java.io.InputStreamReader
import java.io.StringWriter

class MyApplication : Application() {
    companion object {
        lateinit var myApplicationInstance: MyApplication

        lateinit var list: MutableList<com.shiny.keyboard.bean.ClassData>

        const val TAG = "-----------------"
        var defaultFont: Typeface? = null
        const val DB_VERSION = 1
        const val DB_NAME = "db_name"
    }

    override fun onCreate() {
        super.onCreate()
        myApplicationInstance = this
//        ObjectBox.init(this)
        defaultFont = Typeface.createFromAsset(assets, "my_font.ttf")
        initializationSDK()
        dealFile()


    }

    private fun dealFile() {
        val openFile = myApplicationInstance.assets.open("data.json")
        val jsonString = getJsonString(openFile)
        if (jsonString != null) {
            resolveJsonString(jsonString)
        }
    }


    private fun resolveJsonString(string: String) {
        val jsonData = JSONArray(string)
        var dataList: MutableList<ClassData> = mutableListOf()
        for (i in 0 until jsonData.length()) {
            jsonData.getJSONObject(i).run {
                val pName = getString("parent_name")
                val listArray = getJSONArray("keyboard_list")
                var childDataList: MutableList<ChildData> = mutableListOf()
                for (listIndex in 0 until listArray.length()) {
                    listArray.getJSONObject(listIndex).also {
                        val title = it.getString("title")
                        val thUrl = it.getString("thumbUrl")
                        val thGif = it.getString("thumbUrlGif")
                        var zipPath = ""
                        var imgPath = ""
                        var imgGif = ""
                        var imgPreviewGif = ""
                        if (it.has("detail")) {
                            val contentObject =
                                it.getJSONObject("detail").getJSONObject("themeContent")
                            zipPath = contentObject.getString("androidRawZipUrl")
                            imgPath = contentObject.getString("img")
                            imgGif = contentObject.getString("imgGif")
                            imgPreviewGif = contentObject.getString("imgPreviewGif")
                        } else {

                        }
                        childDataList.add(
                            com.shiny.keyboard.bean.ChildData().apply {
                                setImgPath(imgPath)
                                setZipPath(zipPath)
                                setTitleName(title)
                                setImgGif(imgGif)
                                thumbUrl = thUrl
                                thumbGif = thGif
                            })

                    }

                }
                val shuffled = childDataList.shuffled()
                val dataClassData = com.shiny.keyboard.bean.ClassData()
                    .apply {
                        parentName = pName
                        keyboardList = shuffled
                    }
                dataList.add(dataClassData)

            }
        }

        updateDataList(dataList)

    }

    private fun updateDataList(mainList: MutableList<ClassData>) {
        list = mainList

    }

    private fun getJsonString(fileInputStream: InputStream): String? {
        return try {
            //            FileInputStream fileInputStream = new FileInputStream(path);
            val charArray = CharArray(fileInputStream.available())
            var readCount = 0
            val streamReader = InputStreamReader(fileInputStream)
            val bufferedReader = BufferedReader(streamReader)
            val stringWriter = StringWriter()
            while (bufferedReader.read(charArray).also { readCount = it } != -1) {
                stringWriter.write(charArray, 0, readCount)
            }
            stringWriter.toString()
        } catch (e: IOException) {
            ""
        }
    }
    private fun initializationSDK() {
        val APPId = "h67d945e349d31"
        val AppKey = "aedf7a84e6d488296607f2226d46addfb"
        ATSDK.checkIsEuTraffic(this, object : NetTrafficeCallback {
            override fun onResultCallback(isEU: Boolean) {
                if (isEU && ATSDK.getGDPRDataLevel(this@MyApplication) == ATSDK.UNKNOWN) {
                    ATSDK.showGdprAuth(this@MyApplication)
                }
            }

            override fun onErrorCallback(errorMsg: String) {}
        })
        ATSDK.init(this, APPId, AppKey)
        //测试工具
//        ATDebuggerUITest.showDebuggerUI(this,"04e8ce6db9751f67501af2bfed0cd0de0391453a");
        AdManager.loadAllAd()
    }

}